/* CH */
#define CH_OP           0x00000001
#define CH_VOICE        0x00000002
#define CH_PEON         0x00000004

/* CHMODE */
#define CHMODE_TOPIC    0x00000001
#define CHMODE_NOMSG    0x00000002

#define CMODE_INVITE	0x00000001
#define CMODE_MOD	0x00000002
#define CMODE_NOEXT	0x00000004
#define CMODE_PRIV	0x00000008
#define CMODE_SEC	0x00000010
#define CMODE_TOPIC	0x00000020
#define CMODE_ANON	0x00000040
#define CMODE_OPERONLY	0x00000080
#define CMODE_ADMINONLY	0x00000100
#define CMODE_NETADMINONLY 0x00000200

#define CMODE_OP	0x00000400
#define CMODE_HALFOP	0x00000800
#define CMODE_VOICE	0x00001000

/* Channel status macros */
#define	IsChanOp(x)		((x)->modes & CMODE_OP)
#define IsChanHOp(x)	((x)->modes & CMODE_HALFOP)
#define IsChanVoice(x)	((x)->modes & CMODE_VOICE)

void AddNickToChannel (long, struct Channel *, char *, char *);

void NewAddChannel (char *, long);
struct NewChannel *NewFindChannel(char *);

void ChannelMode (struct Channel *, int, char **);
void AddUserToChannel (struct Channel *, char *);
void NewDelChannel (char *);

int is_op (struct NewChannel *, struct User *);

void AddChannel (char *, long);
void RemoveUserFromChannel (struct Channel *, char *);
struct Channel *FindChannel (char *);
int OnChannel (struct Channel *, char *);
int IsOp (struct Channel *, char *);
void DelOp (struct Channel *, char *);

/* XXX new channel tracking */
struct ChanUser *FindChanUser (struct Channel *, char *);

