/* FWServ - IRC Services
** config.h - Hard coded configuration information
**
** Copyright J. Johnston and others.  See README for more details
** Some code Copyright: Jonathan George, Kai Seidler, ircd-hybrid Team,
**                      IRCnet IRCD developers.
**
** $Id: config.h,v 1.10 2003/11/16 18:10:41 ircd Exp $
*/

#ifndef CONFIG_H
#define CONFIG_H

/* These settings are based on the --prefix option to configure, or the
** current directory.  They do not have to be changed.
*/
#define DPATH PREFIX
#define SPATH DPATH "/bin/fwserv"

#define CPATH DPATH "/etc/fwserv.cfg"	/* Path to config */
#define LPATH DPATH "/logs/fwserv.log"	/* Path to logfile */
#define PPATH DPATH "/etc/fwserv.pid"	/* Path to pidfile */

#define TRUE 1

#define IO_LOG
#define ILOG DPATH "/logs/io.log"


/* Define this to enable Nickname Services (NickServ) */
#define NICKSERVICES

/* Define this to enable Channel Services (ChanServ). This requires
** NICKSERVICES to be defined
*/
#define CHANNELSERVICES

/* Define this to enable Memo Services (MemoServ). This requires
** NICKSERVICES to be defined
*/
#define MEMOSERVICES

/* Define this to enable Bot Services (BotServ). This requires
** NICKSERVICES to be defined
*/
#define BOTSERVICES

/* Define this to enable encrypted passwords in operator blocks.  Any
** encryption algorithm supported by your system's crypt library is
** supported by FWServ.
*/
#define CRYPT

/* Define this to enable ecrypting nickname passwords stored in the
** database
*/
#define CRYPT_NICKPASS

/* Define this to enable ecrypting chanserv passwords stored in the
** database
*/
#define CRYPT_CHANPASS

/* Enable this to monitor commands to send to services. The output is
** sent to a channel.
*/
#define SPY

/* Define the channel to send spy messages to */
#define SPY_CHAN "#services"

/* Enable this for debugging purposes */
#define DEBUG

#define DEV_DEBUG

#ifndef DEBUG
  #undef DEV_DEBUG
#endif

/* Define the server type. Read README.SERVERS
** for more information
*/

#undef IRCD_HYB6
#undef IRCD_HYB7
#undef IRCD_BAHAMUT
#undef IRCD_DANCER
#undef IRCD_HYBRID
#define IRCD_HYBSVS

/* STOP STOP STOP */

#ifndef NICKSERVICES
 #undef CHANNELSERVICES
 #undef MEMOSERVICES
 #undef BOTSERVICES
#endif

#ifndef SPY_CHAN
 #undef SPY
#endif

#if !defined(IRCD_HYBRID) && !defined(IRCD_HYB6) && !defined(IRCD_HYB7) && \
    !defined(IRCD_BAHAMUT) && !defined(IRCD_HYBSVS)
#error All ircd types undefined, please set one.
#endif

#endif /* CONFIG_H */
