#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <string.h>
#include <sys/file.h>
#include <assert.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <inttypes.h>
#include <sys/types.h> 
#include <unistd.h>
#include <errno.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/syslog.h>
#include <netinet/in.h>
#include <netdb.h>

#include "setup.h"
#include "config.h"

#ifdef USE_MYSQL
#include "_mysql.h"
#include <mysql.h>
#endif

#include "dlink.h"
#include "structs.h"
#include "defs.h"
#include "replies.h"
#include "patchlevel.h"
#include "serno.h"

#include "opm.h"
#include "opm_common.h"
#include "opm_error.h"
#include "opm_types.h"

#ifdef HAVE_PTHREAD_CREATE
 #define	USE_THREADS
#endif


#define FTMFMT                  "%A, %e %b %Y, %H:%M %Z"

#define CMD_DEBUG	0x0000001
#define CMD_NOFORK      0x0000002
#define CMD_CHROOT	0x0000004

#define	IsNoFork()	(me.flags & CMD_NOFORK)
#define IsDebug()	(me.flags & CMD_DEBUG)

/* Socket States */
#define C_LISTEN	0x00000001 /* Listen Socket */
#define C_UPLINK        0x00000002 /* Uplink Socket */
#define C_CONNECTING	0x00000004 /* Connecting Socket */
#define C_USER		0x00000008 /* Connect User Socket */
#define C_SERVICE	0x00000010 /* Service Check Socket */

/* UMODES */
#define UMODE_INVISIBLE 0x00000001 /* Invisible */
#define UMODE_o		0x00000002

/* FLAGS */
#define FLAG_NONE	0x00000001
#define FLAG_AUTH	0x00000002 /* Authorized */

#define IsAuth(x)	((x)->flags & FLAG_AUTH)

#define LVL_NONE	0x00000001
#define LVL_OPER	0x00000002
#define LVL_ADMIN	0x00000004
#define LVL_IDENT	0x00000008

#define IsIdent(x)	((x)->flags & LVL_IDENT)

#define IsOSOper(x)	((x)->flags & LVL_OPER)
#define IsOSAdmin(x)	((x)->flags & LVL_ADMIN)

#define LVL_ALL		(LVL_OPER|LVL_ADMIN|LVL_IDENT)

#define FATAL	-1

#define FALSE	0
#define TRUE	1

/* Log Levels */
#define	L_ERROR		3
#define L_WARNING	4
#define L_NOTICE	5
#define L_INFO		6
#define L_DEBUG		7

int tokenize(char *, char **);
int generictoken(char, int, char *, char **);
#define msgtoken(x,y)           generictoken(' ', MAXPARA, (x),(y))

/* Link Lists */
dlink_list connection_list;
dlink_list services_list;
dlink_list service_checks;
dlink_list nick_list;
dlink_list channel_list;
dlink_list ourchannel_list;
dlink_list scanned_list;
dlink_list nickkill_list;
dlink_list server_list;
dlink_list newuser_list;
dlink_list newnick_list;
dlink_list user_list;
dlink_list linked_nicks;

dlink_list globaluser_list;
dlink_list rchannel_list;

void evh_reconnect_uplink(void *unused);

struct CmdTable {
  char* name;
  struct CmdTable *next;
  int (*handler)();
  int flag;
};

extern int foreground;
extern int Running;
extern int uplinksock;
extern int ports;
extern int dorehash;
extern int allow_scanning;
extern char *version_string;

#define n_UtilServ "UtilServ"

#ifdef USE_MYSQL
 #define NickServDB "NickServ"
 #define ChanServDB "ChanServ"
#else
 #define NickServDB "nick.db"
 #define ChanServDB "chan.db"
#endif

void SendNicks (void);

#define OFLAG_OPER  0x00000001
#define OFLAG_ADMIN 0x00000002

extern struct Token oper_flags[];

#ifdef SPY
void JoinSpy (void);
void Spy (char *, char *, ...);
#endif
