#include "fwserv.h"

#ifdef USE_MYSQL

MYSQL *
connect_db (void)
{
  MYSQL *conn;

  conn = mysql_init(NULL);

  if (conn == NULL)
  {
    log(1, "mysql_init() failed");
    return (NULL);
  }

  if (mysql_real_connect (conn, me.mhost, me.muser, me.mpass, me.mdb, 0, NULL, 0) <= 0)
  {
    log(1, "mysql_real_connect() failed: %s", mysql_error(conn));
    return (NULL);
  }

  return (conn);
}

MYSQL_RES *sql_query_res (char *fmt,...)
{
    MYSQL_RES	*res;
    char	query[2048];
    va_list	ap;

    va_start(ap, fmt);
    vsnprintf(query, BUFSIZE, fmt, ap);
    va_end (ap);

    /*mysql_ping(me.mptr);*/

    if (!me.mptr)
		return NULL;

    if (mysql_real_query (me.mptr, query, strlen(query)) < 0)
    {
		log (L_INFO, "mysql_real_query() failed: %s", mysql_error(me.mptr));
		return NULL;
    }

    res = mysql_store_result (me.mptr);
    return res;
}

int sql_query (char *fmt, ...)
{
    char    query[2048];
    va_list ap;

    va_start(ap, fmt);
    vsnprintf(query, BUFSIZE, fmt, ap);
    va_end (ap);

    mysql_ping(me.mptr);

    if (!me.mptr)
        return NULL;

    if (!mysql_real_query (me.mptr, query, strlen(query)) < 0)
    {
	log(1, "mysql_real_query() failed: %s", mysql_error(me.mptr));
	return 0;
    }

    return 1;
}

#endif
