/* FWServ */

#include "fwserv.h"
#include "config.h"
#include "user.h"

int sts (char *, ...);
void notice (struct User *, char *, char *, ...);

void
notice (struct User *u, char *from, char *fmt, ...)
{
    va_list ap;
    char buf[BUFSIZE];
    struct User *user;

/*
  if ((user = NewFindUser(from)) == NULL)
    return;
*/

    if ((from[0] == '\0') || (u->nick[0] == '\0'))
	return;

    va_start(ap, fmt);
    vsnprintf(buf, BUFSIZE, fmt, ap);
    va_end (ap);

    sts(":%s NOTICE %s :%s", from, u->nick, buf);

    return;
}

void privmsg (char *to, char *from, char *fmt, ...)
{
    va_list ap;
    char    msg[BUFSIZE];

    if ((to[0] == '\0') || (from[0] == '\0'))
	return;

    va_start (ap, fmt);
    vsnprintf (msg, BUFSIZE, fmt, ap);
    va_end (ap);

    if (me.privmsg > 0)
	sts (":%s PRIVMSG %s :%s", from, to, msg);
    else
	sts (":%s NOTICE %s :%s", from, to, msg);

    return;
}

void wallops (char *from, char *fmt, ...)
{
	va_list	ap;
	char	msg[BUFSIZE];

	if ((from[0] == '\0'))
		return;

	va_start (ap, fmt);
	vsnprintf (msg, BUFSIZE, fmt, ap);
	va_end (ap);

	sts (":%s WALLOPS :%s", from, msg);

	return;
}

/* Send string to server
 * append \n
 * Some code copright W. Campbell
 */
int
sts(char *fmt,...)
{     
  va_list ap;
  char buf[BUFSIZE];
  
  va_start(ap, fmt);
  vsnprintf(buf, BUFSIZE, fmt, ap);

#ifdef IO_LOG
  io_log("S: %s", buf);
#endif
  
  strlcat(buf, "\n", BUFSIZE);

  if (uplinksock == -1)
  {
    log(1, "Not Connected");
    return;
  }
     
  if((write(uplinksock, buf, strlen(buf))) == -1)
    {
      log(1, "Write Error. (%d)", uplinksock);
      close(uplinksock);
      del_connection(uplinksock);
      uplinksock = -1;
      eventAdd("Reconnect Uplink", evh_reconnect_uplink, NULL, me.reconnect);
      return 1;
    }
        
  va_end (ap);
        
  return 0;
}
