/* FWServ */

#include "fwserv.h"
#include "signals.h"
#include "config.h"
#include "user.h"

void SigTerm (int sig)
{
	wallops (me.name, "Received SIGTERM :Exiting");
    SendQuit ("Received SIGTERM :Exiting");

    DoSave ();
    shutdown(uplinksock, SHUT_RDWR);
    del_connection(uplinksock);
    log(1, "Received SIGTERM: Exiting");
    mysql_close(me.mptr);

    sleep(1);
    exit(0);
}

void SigInt (int sig)
{
	wallops (me.name, "Received SIGINT :Exiting");
    SendQuit ("Received SIGINT :Exiting");

    DoSave ();
    shutdown(uplinksock, SHUT_RDWR);
    del_connection(uplinksock);
    log(1, "Received SIGINT: Exiting");
    mysql_close(me.mptr);

    sleep(1);
    exit(0);
}

void SigUsr1 (int sig)
{
	wallops (me.name, "Received SIGUSR1 :Relinking");
    SendQuit ("Received SIGUSR1 :Relinking");

    shutdown(uplinksock, SHUT_RDWR);
    del_connection(uplinksock);
    sleep(me.reconnect);

    ConnectUplink(me.uplink, me.port);
    return;
}

void SigUsr2 (int sig)
{
  struct User *u;
  struct Server *server;
  dlink_node *dl;

  DLINK_FOREACH(dl, user_list.head)
  {
    u = (struct User *)dl->data;
    printf ("%s (%s) Connected via %s\n", u->nick, u->realhost, u->server->name);
  }

/*
  DLINK_FOREACH(dl, server_list.head)
  {
    server = (struct Server *)dl->data;
    printf ("%s - %s\n", server->name, server->desc);
  }
*/
}

void SigHup (int sig)
{
  wallops (me.name, "Caught SIGHUP. Rehashing.");
  log(1, "Caught SIGHUP, Rehashing config");
    rehash();
  
}

void SigSegv (int sig)
{
  sts(":%s QUIT :Received SIGSEGV :Eeeek", OperServ.nick);
  sts(":%s QUIT :Received SIGSEGV :Eeeek", n_UtilServ);

#ifdef NICKSERVICES
  sts(":%s QUIT :Received SIGSEGV :Eeeek", NickServ.nick);
#ifdef CHANNELSERVICES
  sts(":%s QUIT :Received SIGSEGV :Eeeek", ChanServ.nick);
#endif
#ifdef MEMOSERVICES
  sts(":%s QUIT :Received SIGSEGV :Eeeek", MemoServ.nick);
#endif
#ifdef BOTSERVICES
  sts(":%s QUIT :Received SIGSEGV :Eeeek", BotServ.nick);
#endif
#endif

/*
  SaveNicks();
  SaveMemos();
*/
    DoSave ();
  sts("WALLOPS :Received SIGSEGV :Eeeek");
  close(uplinksock);
  abort();
}
