/*
 * wrapper to run FWServ Chroot'd
 *
 * Borrowed from Hwy's Hybrid 6.3 Chroot Tool
 */

#define ROOTDIR "/home/jeremy/FWServ"
#define EXENAME "/bin/fwserv"
#define USER "jeremy"

#include <pwd.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>

int main()
{
        struct passwd *pentry;

        pentry = getpwnam (USER);
        if (pentry == NULL) { perror ("no user"); exit (10); }

        if (chdir (ROOTDIR)) { perror ("chdir"); exit (1); }
        if (chroot (ROOTDIR)) { perror ("chroot"); exit (2); }
        if (chdir ("/")) { perror ("chdir root"); exit (3); }

        if (setregid (pentry->pw_gid, pentry->pw_gid)) { perror ("setregid"); exit (4); }
        if (setreuid (pentry->pw_uid, pentry->pw_uid)) { perror ("setreuid"); exit (5); }

        execl (EXENAME, EXENAME, NULL);

        perror ("exec"); exit (20);
}
